import '@tarojs/async-await'
import Taro, { Component } from '@tarojs/taro'
import { Provider } from '@tarojs/redux'
import Home from './pages/home'
import configStore from './store'

import './app.scss'

// 如果需要在 h5 环境中开启 React Devtools
// 取消以下注释：
// if (process.env.NODE_ENV !== 'production' && process.env.TARO_ENV === 'h5')  {
//   require('nerv-devtools')
// }

const store = configStore()

class App extends Component {

  config = {
    pages: [
      //'pages/index/index', // index页面 
      'pages/home/home',//首页 ---------------------
      'pages/login/login',//登入页面 ---------------------
      'pages/shop/shop',//店铺页面 ---------------------
      'pages/goods/goods',// 商品页面 ---------------------
      'pages/goodsPublish/goodsPublish',// 商品发布页面 ---------------------
      'pages/supplyDemandPublish/supplyDemandPublish',// 供求发布页面 ---------------------
      'pages/mySupplyDemand/mySupplyDemand',// 我的供求列表页面 ---------------------
      'pages/myGoodsEdit/myGoodsEdit',// 我的商品编辑页面 ---------------------
      'pages/allDemanding/allDemanding',// 所有供求页面 ---------------------
      'pages/myGoodList/myGoodList',// 我的商品列表页面 --------------------- 编辑商品按键
      'pages/myDemandSupplyEdit/myDemandSupplyEdit',// 我的供求编辑页面 ---------------------
      'pages/supplyDemandView/supplyDemandView',// 查看单个供求页面
      'pages/grabOrderPage/grabOrderPage',// 抢单页面
      'pages/myNeeds/myNeeds',// 我的需求页面
      'pages/myNeedsView/myNeedsView',// 单个需求查看页面
      'pages/myNeedsEdit/myNeedsEdit',// 单个需求编辑页面
      'pages/myNeedsPublish/myNeedsPublish',// 需求发布
    
      // 'pages/shopDescription/shopDescription',
    ],
    window: {
      backgroundTextStyle: 'light',
      navigationBarBackgroundColor: '#fff',
      navigationBarTitleText: 'WeChat',
      navigationBarTextStyle: 'black',
      // enablePullDownRefresh:true
      onReachBottomDistance: 0
    },

    tabBar: {
      list: [{
        pagePath: "pages/home/home",
        text: "首页",
        iconPath: "./icons/home.png",
        selectedIconPath: "./icons/home-actived.png"
      }, {
        pagePath: "pages/goodsPublish/goodsPublish",
        text: "商品发布",
        iconPath: "./icons/box.png",
        selectedIconPath: "./icons/box-actived.png"
      }, {
        pagePath: "pages/supplyDemandPublish/supplyDemandPublish",
        text: "供求发布",
        iconPath: "./icons/publish.png",
        selectedIconPath: "./icons/publish-actived.png"
      }
        , {
        pagePath: "pages/mySupplyDemand/mySupplyDemand",
        text: "我的供求",
        iconPath: "./icons/menu.png",
        selectedIconPath: "./icons/menu-actived.png"
      }
        , {
        pagePath: "pages/myNeeds/myNeeds",
        text: "我的需求",
        iconPath: "./icons/user.png",
        selectedIconPath: "./icons/user-actived.png"
      }
      ],
      color: '#333',
      selectedColor: '#333',
      backgroundColor: '#fff',
      borderStyle: '#ccc'
    }


  }

  componentDidMount() { }

  componentDidShow() { }

  componentDidHide() { }

  componentCatchError() { }

  componentDidCatchError() { }

  // 在 App 类中的 render() 函数没有实际作用
  // 请勿修改此函数
  render() {
    return (
      <Provider store={store}>
        <Home />
      </Provider>
    )
  }
}

Taro.render(<App />, document.getElementById('app'))
